* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
* Diese Datei: xvar07.sps
*   Dateiformat: Dos\Windows
*   Zeichensatz: Windows-1252
*   SPSS 24.0.0.1.
* Download: 
*    https://www.gesis.org/missy/files/documents/MZ/misc/TR_10-03_SPSS.zip
* Version: 10/2019.
*
* Konstruktion der Hilfsmerkmale fr Scientific Use File Mikrozensus 2007
* 
* Zusammenfhrung der Hilfsmerkmale mit SUF mittels Identifikator satznr
* 
* Siehe: 
* Schimpl-Neimanns, Bernhard: Varianzschtzung fr Mikrozensus 
* Scientific Use Files ab 2005. GESIS-Technical Report Nr. 2010/03. 
* Mannheim: GESIS.
*   URL: http://www.gesis.org/fileadmin/upload/forschung/publikationen/
*        gesis_reihen/gesis_methodenberichte/2010/TechnicalReport_10-03.pdf
* berarbeitete Fassung verffentlicht als:
* Schimpl-Neimanns, Bernhard (2011): Schtzung des Stichprobenfehlers 
* in Mikrozensus Scientific Use Files ab 2005, AStA Wirtschafts- und 
* Sozialstatistisches Archiv 5 (1): 19-38. DOI: 10.1007/s11943-011-0092-4. 
* 
* Datenbeschreibung:
*   https://www.gesis.org/missy/metadata/MZ/2007/
* 
* nderungen gegenber frheren Versionen:
* - Syntax vereinfacht.
* - Berechnung der Mittelwerte der Indikatoren der Hilfsmerkmale bercksichtigt
*   nur die Bevlkerung am Hauptwohnsitz.
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -.

* SPSS Version 24.0.0.1.

* Lokales Arbeitsverzeichnis eintragen, z. B. "c:\temp".
cd "Arbeitsverzeichnis".

* Rekodierung doppelter Identifikatoren im SUF 2007
* http://www.gesis.org/fileadmin/upload/dienstleistung/daten/amtl_mikrodaten/mz/
*        syntax/misc/ID_2007.sps
* 
*  get file='<mz2007.sav>'. 
*  (...) .
*  Sortierung der Ausgangsdaten VOR Vernderungen von EF4 und EF5.
*  sort cases by ID_Org.
*  (...) .
*  save /outfile = "<mz2007r.sav>".

* Daten einlesen, ggf. um Verzeichnis ergnzen oder ohne Variablenauswahl. 
* - hier: MZ SUF 2007 mit rekodierter Haushaltsnummer (EF4R).
get file = "mz2007r.sav" /keep
  EF1   /* Bundesland
  EF3   /* Nr. des Auswahlbezirks (systemfrei)
  EF4   /* Nr. des Haushalts im Auswahlbezirk (laufend) 
  EF5   /* Nr. der Person im Haushalt (laufend)
  EF12  /* Berichtsquartal
  EF29  /* Erwerbstyp
  EF30  /* Bevlkerung: Haupt- oder Nebenwohnsitz
  EF31  /* Bevlkerung: Privathaushalte
  EF44  /* Alter
  EF46  /* Geschlecht
  EF117 /* Stellung im Beruf
  EF369 /* 1. Staatsangehrigkeit
  EF371 /* Staatsangehrigkeit typisiert
  EF570 /* Gebudegrenklassen 
  EF952 /* Hochrechnungsfaktor: Jahr
  EF4R  /* Nr. des Haushalts im Auswahlbezirk (systemfrei) - plausibilisiert
  EF5R  /* Nr. der Person im Haushalt (EF5) rekodiert
  .
DATASET NAME $DataSet WINDOW=FRONT.

* Deklaration fehlender Werte aufheben.
missing values all().

* satznr fuer spteres Zusammenfhren mit MZ .
compute satznr = $casenum.
var label satznr "Fortlaufende Personennummer (Satznr. File)".
formats satznr (f6.0).


* Beachte: Die Hilfsmerkmale werden lnderspezifisch gebildet. 
*    Die Lnder sind im MZ 2005 und 2006 nach alphabetischer Sortierung, 
*    ab MZ 2007 (wie bis 2004) gem amtlichem Gemeindeschlssel codiert.

* Vorlufige fortlaufende Haushaltsnummer bilden .
*   Variablen, die zur Abgrenzung eines Haushalts erforderlich sind; siehe
*   https://www.gesis.org/missy/materials/MZ/tools/abgrenzungerhebungseinheiten
*   EF1   Bundesland
*   EF3   Nr. des Auswahlbezirks
*   EF12  Berichtsquartal
*   EF4   Nr. des Haushalts im Auswahlbezirk .
* 
*  Im MZ 2007 ist bei der Konstruktion der Haushaltsnummer (EF4R) das 
*  Berichtsquartal (EF12) bercksichtigt, sodass auf die Verwendung 
*  von EF12 bei der folgenden Haushaltsabgrenzung verzichtet werden
*  kann. 
sort cases by EF1 EF3 EF4R.

if (EF1<>lag(EF1) | EF3<>lag(EF3) | EF4R<>lag(EF4R) ) hnr=hnr+1.
leave hnr.
compute hhnr=hnr+1.
formats hnr hhnr (f6.0).
execute.

* Personennummer im Haushalt .
sort cases by hhnr.
compute pr=0.
do if (hhnr=lag(hhnr)). 
  compute pr=lag(pr)+1.
else.
  compute pr=0.
end if.
execute.
compute pnr=pr+1.
formats pr pnr (f2.0).
var label pnr "Personennummer im HH".
execute.

compute pnrGU = pnr*(EF31=2).
var label pnrGU "Personennummer in HH mit Pers. in Gemeinschaftsunterkunft".
formats pnrGU (f2.0).
execute.

* Neue Haushaltsnummer bilden .
*     Pers. in Gemeinschaftsunterkuenften bilden einen eigenen "Haushalt" .
sort cases by EF1 EF3 EF4R pnrGU satznr .
if (EF1<>lag(EF1) | EF3<>lag(EF3) | EF4R<>lag(EF4R) | pnrGU<>lag(pnrGU)) nr=nr+1.
leave nr.
compute hhnr=nr+1.
execute.
var label hhnr "Fortlaufende Haushaltsnummer (Pers in GU: eigene Nr.)".
formats nr hhnr (f6.0).
execute.

sort cases by satznr.

* === Abgrenzung der Hilfsmerkmale === .
* Siehe bersicht 3: Realisiertes Hochrechnungsmodell nach Bundeslndern  .
*       im 2. Vierteljahr 2005, S. 1046 in: Afentakis, A. & Bihler, W.     .
*       (2005): Das Hochrechnungsverfahren beim unterjhrigen Mikrozensus .
*       ab 2005, Wirtschaft und Statistik 10/2005, 1039-1048.              .

recode EF46 (1=0) (2=1) into sex.
var label    sex "Geschlecht EF46".
formats sex (f1.0).
value labels sex 0 "M" 1 "W".

recode EF44 (0 thru 14=1) (15 thru 44=0) (45 thru 95=2) into age.
var label age "Altersgruppe EF44".
value labels  age 0 "15-44" 1 "0-14 "2 "45+".
formats age (f1.0).

recode EF371 (1=0) (2=2) (3=3) into nat.
if (nat=3 & EF369=34) nat=1.
var label nat "Staatsangehrigkeit EF371, EF369".
value labels nat 0 "DE" 1 "TR" 2 "EU" 3 "SO".
formats nat (f1.0).

recode EF117 (9=1) (10=2) (else=0) into zsw.
var label    zsw "Bevlkerungsgruppe".
value labels zsw 0 "ZIVB" 1 "SOLD" 2 "WEHR".
formats zsw (f1.0).
execute.

* Hochrechnungsterme: .
* H1: Land x Bevlkerung insgesamt je Monat .
* H2: Land x Geschlecht (m, w) x Alter (<15, 15 bis 44, 45+ Jahre)  .
* H3: Land x Staatsangehrigk. (D, TR, EU25, nEU) x Geschlecht (m, w) .
* H4: Land x Bevlkerungstyp (Zeit- und Berufssoldaten einschl. ...) .

* Fr Lnder mit Hochrechnungstermen H1 bis H4 .
compute x1  = 1.        /* H1: Konstante [m, Alter=15-44, Zivilbev.] */
compute x2  = (sex=1).           /* H2: Geschlecht=w */
compute x3  = (age=1).           /* H2: Alter=<15 */
compute x4  = (age=2).           /* H2: Alter=45+ */
compute x5  = (sex=1) * (age=1). /* H2: Geschlecht=w x Alter=<15 */
compute x6  = (sex=1) * (age=2). /* H2: Geschlecht=w x Alter=45+ */
compute x7  = (nat=1).           /* H3: Staatsang.=TR */
compute x8  = (nat=2).           /* H3: Staatsang.=EU */
compute x9  = (nat=3).           /* H3: Staatsang.=SO */
compute x10 = (nat=1) * (sex=1). /* H3: Staatsang.=TR x Geschlecht=w */
compute x11 = (nat=2) * (sex=1). /* H3: Staatsang.=EU x Geschlecht=w */
compute x12 = (nat=3) * (sex=1). /* H3: Staatsang.=SO x Geschlecht=w */
compute x13 = (zsw=1).           /* H4: Bevlk.gr=Soldaten */
compute x14 = (zsw=2).           /* H4: Bevlk.gr=Wehrpfl */
execute.

* === Baden-Wrttemberg (EF1=08) === .
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28.
compute Y = X*(EF1=8).
end repeat.
execute.

* === Bayern (EF1=09) ===.
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42.
compute Y = X*(EF1=9).
end repeat.
execute.

* === Berlin (EF1=11) === .
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x43, x44, x45, x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56.
compute Y = X*(EF1=11).
end repeat.
execute.

* === Hessen (EF1=06) === .
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70.
compute Y = X*(EF1=6).
end repeat.
execute.

* === Niedersachsen (EF1=03) ===.
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x71, x72, x73, x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84.
compute Y = X*(EF1=3).
end repeat.
execute.

* === Rheinland-Pfalz (EF1=07) ===.
do repeat X = x1,  x2,  x3,  x4,  x5,  x6,  x7,  x8,  x9,  x10, x11, x12, x13, x14
         /Y = x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98.
compute Y = X*(EF1=7).
end repeat.
execute.

* === Schleswig-Holstein (EF1=01) ===.
do repeat X = x1,  x2,   x3,   x4,   x5,   x6,   x7,   x8,   x9,   x10,  x11,  x12,  x13,  x14
         /Y = x99, x100, x101, x102, x103, x104, x105, x106, x107, x108, x109, x110, x111, x112.
compute Y = X*(EF1=1).
end repeat.
execute.

* === Nordrhein-Westfalen (EF1==05) === siehe unten .

* Reduziertes Hochrechnungsmodell H3 .
*    R2: Staatsangehrigkeit (deutsch, nicht deutsch) x Geschlecht .
* Fuer Lnder: Brandenburg, Mecklenburg-Vorpommern, Sachsen, Sachsen-Anhalt, Thringen .
compute xn  = (nat<>0).            /* x7  - x9  */
compute xng = (nat<>0) * (sex=1).  /* x10 - x12 */
execute.

* === Brandenburg (EF1=12) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng,  x13,  x14
         /Y = x113, x114, x115, x116, x117, x118, x119, x120, x121, x122.
compute Y = X*(EF1=12).
end repeat.
execute.

* === Mecklenburg-Vorpommern (EF1=13) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng,  x13,  x14
         /Y = x123, x124, x125, x126, x127, x128, x129, x130, x131, x132.
compute Y = X*(EF1=13).
end repeat.
execute.

* === Sachsen (EF1=14) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng,  x13,  x14
         /Y = x133, x134, x135, x136, x137, x138, x139, x140, x141, x142.
compute Y = X*(EF1=14).
end repeat.
execute.

* === Sachsen-Anhalt (EF1=15) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng,  x13,  x14
         /Y = x143, x144, x145, x146, x147, x148, x149, x150, x151, x152.
compute Y = X*(EF1=15).
end repeat.
execute.

* === Thringen (EF1=16) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng,  x13,  x14
         /Y = x153, x154, x155, x156, x157, x158, x159, x160, x161, x162.
compute Y = X*(EF1=16).
end repeat.
execute.

* Reduziertes Hochrechnungsmodell H3, H4 .
*    R1, R2: Ohne Unterscheidung nach Bevlkerungstyp .
* Fr Bremen (Annahme: R2 ) und Hamburg .

* === Bremen (EF1=04) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng
         /Y = x163, x164, x165, x166, x167, x168, x169, x170.
compute Y = X*(EF1=4).
end repeat.
execute.

* === Hamburg (EF1=02) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   xn,   xng
         /Y = x171, x172, x173, x174, x175, x176, x177, x178.
compute Y = X*(EF1=2).
end repeat.
execute.

* Reduziertes Hochrechnungsmodell H4 .
* Fr Saarland: ohne Unterscheidung nach Bevlkerungstyp, aber .
*             R1: Staatsangehrigkeit (D, TR, EU25, nEU25) .
* === Saarland (EF1=10) ===.
do repeat X = x1,   x2,   x3,   x4,   x5,   x6,   x7,   x8,   x9,   x10,  x11,  x12
         /Y = x179, x180, x181, x182, x183, x184, x185, x186, x187, x188, x189, x190.
compute Y = X*(EF1=10).
end repeat.
execute.

* === Nordrhein-Westfalen (EF1=05) === .
do repeat X = x1 to x14.
compute X = X * (EF1=5).
end repeat.
execute.

* Hilfsmerkmale sind nur fr die Bevlkerung am Hauptwohnsitz definiert .
do repeat X = x1 to x190.
compute X = X * (EF30>=1 & EF30<=2).
end repeat.
execute.

* Zusammenfassungen werden nicht mehr bentigt.
delete variables xn xng.                                                        
execute.

formats x1 to x190 (f1.0).
execute.

* Arithm. Mittelwerte der Hilfsmerkmale auf Haushaltsebene bilden.
sort cases by hhnr.

* hhgr: Anzahl der Personen am Hauptwohnsitz pro hhnr.
aggregate outfile = * mode=addvariables /presorted /break hhnr  /hhgr = CIN(EF30,1,2).
formats hhgr (f3.0).
execute.

aggregate outfile = * mode=addvariables /presorted /break hhnr 
 /t1 = sum(x1)   /t2 = sum(x2)   /t3 = sum(x3)   /t4 = sum(x4)   /t5 = sum(x5)
 /t6 = sum(x6)   /t7 = sum(x7)   /t8 = sum(x8)   /t9 = sum(x9)   /t10 = sum(x10)
 /t11 = sum(x11) /t12 = sum(x12) /t13 = sum(x13) /t14 = sum(x14) /t15 = sum(x15)
 /t16 = sum(x16) /t17 = sum(x17) /t18 = sum(x18) /t19 = sum(x19) /t20 = sum(x20)
 /t21 = sum(x21) /t22 = sum(x22) /t23 = sum(x23) /t24 = sum(x24) /t25 = sum(x25)
 /t26 = sum(x26) /t27 = sum(x27) /t28 = sum(x28) /t29 = sum(x29) /t30 = sum(x30)
 /t31 = sum(x31) /t32 = sum(x32) /t33 = sum(x33) /t34 = sum(x34) /t35 = sum(x35)
 /t36 = sum(x36) /t37 = sum(x37) /t38 = sum(x38) /t39 = sum(x39) /t40 = sum(x40)
 /t41 = sum(x41) /t42 = sum(x42) /t43 = sum(x43) /t44 = sum(x44) /t45 = sum(x45)
 /t46 = sum(x46) /t47 = sum(x47) /t48 = sum(x48) /t49 = sum(x49) /t50 = sum(x50)
 /t51 = sum(x51) /t52 = sum(x52) /t53 = sum(x53) /t54 = sum(x54) /t55 = sum(x55)
 /t56 = sum(x56) /t57 = sum(x57) /t58 = sum(x58) /t59 = sum(x59) /t60 = sum(x60)
 /t61 = sum(x61) /t62 = sum(x62) /t63 = sum(x63) /t64 = sum(x64) /t65 = sum(x65)
 /t66 = sum(x66) /t67 = sum(x67) /t68 = sum(x68) /t69 = sum(x69) /t70 = sum(x70)
 /t71 = sum(x71) /t72 = sum(x72) /t73 = sum(x73) /t74 = sum(x74) /t75 = sum(x75)
 /t76 = sum(x76) /t77 = sum(x77) /t78 = sum(x78) /t79 = sum(x79) /t80 = sum(x80)
 /t81 = sum(x81) /t82 = sum(x82) /t83 = sum(x83) /t84 = sum(x84) /t85 = sum(x85)
 /t86 = sum(x86) /t87 = sum(x87) /t88 = sum(x88) /t89 = sum(x89) /t90 = sum(x90)
 /t91 = sum(x91) /t92 = sum(x92) /t93 = sum(x93) /t94 = sum(x94) /t95 = sum(x95)
 /t96 = sum(x96) /t97 = sum(x97) /t98 = sum(x98) /t99 = sum(x99)
 /t100 = sum(x100) /t101 = sum(x101) /t102 = sum(x102) /t103 = sum(x103) 
 /t104 = sum(x104) /t105 = sum(x105) /t106 = sum(x106) /t107 = sum(x107)
 /t108 = sum(x108) /t109 = sum(x109) /t110 = sum(x110) /t111 = sum(x111)
 /t112 = sum(x112) /t113 = sum(x113) /t114 = sum(x114) /t115 = sum(x115)
 /t116 = sum(x116) /t117 = sum(x117) /t118 = sum(x118) /t119 = sum(x119)
 /t120 = sum(x120) /t121 = sum(x121) /t122 = sum(x122) /t123 = sum(x123)
 /t124 = sum(x124) /t125 = sum(x125) /t126 = sum(x126) /t127 = sum(x127)
 /t128 = sum(x128) /t129 = sum(x129) /t130 = sum(x130) /t131 = sum(x131)
 /t132 = sum(x132) /t133 = sum(x133) /t134 = sum(x134) /t135 = sum(x135)
 /t136 = sum(x136) /t137 = sum(x137) /t138 = sum(x138) /t139 = sum(x139)
 /t140 = sum(x140) /t141 = sum(x141) /t142 = sum(x142) /t143 = sum(x143)
 /t144 = sum(x144) /t145 = sum(x145) /t146 = sum(x146) /t147 = sum(x147)
 /t148 = sum(x148) /t149 = sum(x149) /t150 = sum(x150) /t151 = sum(x151)
 /t152 = sum(x152) /t153 = sum(x153) /t154 = sum(x154) /t155 = sum(x155)
 /t156 = sum(x156) /t157 = sum(x157) /t158 = sum(x158) /t159 = sum(x159)
 /t160 = sum(x160) /t161 = sum(x161) /t162 = sum(x162) /t163 = sum(x163)
 /t164 = sum(x164) /t165 = sum(x165) /t166 = sum(x166) /t167 = sum(x167)
 /t168 = sum(x168) /t169 = sum(x169) /t170 = sum(x170) /t171 = sum(x171)
 /t172 = sum(x172) /t173 = sum(x173) /t174 = sum(x174) /t175 = sum(x175)
 /t176 = sum(x176) /t177 = sum(x177) /t178 = sum(x178) /t179 = sum(x179)
 /t180 = sum(x180) /t181 = sum(x181) /t182 = sum(x182) /t183 = sum(x183)
 /t184 = sum(x184) /t185 = sum(x185) /t186 = sum(x186) /t187 = sum(x187)
 /t188 = sum(x188) /t189 = sum(x189) /t190 = sum(x190).

* nicht bentigte Variablen lschen.
delete variables x1 to x190.
execute.

do repeat X=t1 to t190 
         /Y=x1 to x190.
+ if (EF30>=1 & EF30<=2) Y=X / hhgr.
+ recode Y (sysmis=0).
end repeat.
execute.

* nicht bentigte Variablen lschen.
delete variables t1 to t190.
execute.

formats x1 to x190 (f9.6).
execute.

sort cases by satznr .

file label "Hilfsmerkmale fr gebundene Hochrechnung MZ 2007".

save outfile = 'xvar07.sav' /keep = satznr hhnr x1 to x190.

* ####################### PROGRAMMENDE ####################### . 
